import 'dart:io';
import 'dart:async';
import 'package:webreflect/webreflect.dart';

main() async {
  HttpServer.bind('localhost', 2092).then((HttpServer server) async {
    await for (var r in server) {
      var socket = await WebSocketTransformer.upgrade(r);
      var wr = new WebReflect(socket);

      wr.set('root', '<div id="time"></div>');

      new Timer.periodic(new Duration(seconds: 1), (Timer t) {
        if (socket.readyState != WebSocket.OPEN) {
          t.cancel();
          print('conn canceled');
        }

        wr.append('time', '<p>${new DateTime.now()}</p>');
      });

      print('msg sent');
    }
  });
}