// Copyright (c) 2017, kari. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

var buffer:Object = {};
var websocket: WebSocket;


function wrConnect(address) {
  websocket = new WebSocket('ws://' + address);
  websocket.addEventListener('message', handler);
};

function wrBuffer(id, value) {
  buffer[id] = value;
};

function wrCommitBuffer() {
  for (var id in buffer) {
    if (buffer.hasOwnProperty(id)) {
      var value = buffer[id];
      websocket.send(JSON.stringify({
        type: 'commit',
        id: id,
        value: value
      }));
    }
  }
  buffer = {};
};

function wrEvent(id, eventname) {
  websocket.send(JSON.stringify({
    type: 'event',
    id: id,
    value: eventname
  }));
};


function  handler(this: WebSocket, e: MessageEvent) {
  var msg = JSON.parse(e.data);
  console.log(JSON.stringify(msg));

  var type  = msg['type'];
  var id    = msg['id'];
  var value = msg['value'];

  switch (type) {
    case 'set':
      setHTML(id, value);
      break;
    case 'append':
      appendHTML(id, value);
      break;
    case 'javascript':
      eval(value);
      break;
    default:
      log('未知消息类型' + type);
  }
}

function log(message) {
  console.log(message);
}